# E-Invoicing With the E-Invoicing feature, Zuora supports electronic invoices through an integration with partners that have a local presence, where required, which guarantees compliance with local invoice regulations. All the operations in this section are available only if you have the E-Invoicing feature enabled. ## List e-invoicing service providers - [GET /v1/einvoice/service-providers](https://developer.zuora.com/v1-api-reference/api/e-invoicing/get_einvoicingserviceproviders.md): Lists information about e-invoicing service providers. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Create an e-invoicing service provider - [POST /v1/einvoice/service-providers](https://developer.zuora.com/v1-api-reference/api/e-invoicing/post_einvoicingserviceprovider.md): Creates an e-invoicing service provider. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Delete an e-invoicing service provider - [DELETE /v1/einvoice/service-providers/{key}](https://developer.zuora.com/v1-api-reference/api/e-invoicing/delete_einvoicingserviceprovider.md): Deletes an e-invoicing service privider. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Retrieve an e-invoicing service provider - [GET /v1/einvoice/service-providers/{key}](https://developer.zuora.com/v1-api-reference/api/e-invoicing/get_einvoicingserviceprovider.md): Retrieves information about an e-invoicing service privider. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Update an e-invoicing service provider - [PUT /v1/einvoice/service-providers/{key}](https://developer.zuora.com/v1-api-reference/api/e-invoicing/put_updateeinvoicingserviceprovider.md): Updates information about an e-invoicing service privider. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## List e-invoicing business regions - [GET /v1/einvoice/business-regions](https://developer.zuora.com/v1-api-reference/api/e-invoicing/get_einvoicingbusinessregions.md): Lists information about e-invoicing business regions. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Create an e-invoicing business region - [POST /v1/einvoice/business-regions](https://developer.zuora.com/v1-api-reference/api/e-invoicing/post_createeinvoicingbusinessregion.md): Creates an e-invoicing business region. You must create business regions to store the business detail information as a seller. If you have multiple GSTINs for different states, you can create multiple business region objects for India. The business region objects can be looked up according to the country and state, and its related fields can be mapped accordingly within the e-invoice file template. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Delete an e-invoicing business region - [DELETE /v1/einvoice/business-regions/{key}](https://developer.zuora.com/v1-api-reference/api/e-invoicing/delete_einvoicingbusinessregion.md): Deletes an e-invoicing business region by key. The key can be the unique ID or number of an e-invoicing business region. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Retrieve an e-invoicing business region - [GET /v1/einvoice/business-regions/{key}](https://developer.zuora.com/v1-api-reference/api/e-invoicing/get_einvoicingbusinessregion.md): Retrieves information about an e-invoicing business region. You can search for an e-invoicing business region by key. The key can be the unique ID or number of an e-invoicing business region. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Update an e-invoicing business region - [PUT /v1/einvoice/business-regions/{key}](https://developer.zuora.com/v1-api-reference/api/e-invoicing/put_updateeinvoicingbusinessregion.md): Updates an e-invoicing business region by key. The key can be the unique ID or number of an e-invoicing business region. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## List mandates for downloading files - [GET /v1/e-invoice/mandates](https://developer.zuora.com/v1-api-reference/api/e-invoicing/geteinvoicemandates.md): Fetches mandates for downloading files based on the country code, category, and process type selection. This API operation returns the the list of file formats in which the document can be downloaded. Note: This operation is available only if you have the E-Invoicing feature for Avalara in Early Availabiltiy phase enabled. ## Retrieve a mandate for downloading a file - [GET /v1/invoices/{invoiceKey}/e-invoice/mandate](https://developer.zuora.com/v1-api-reference/api/e-invoicing/geteinvoicemandateoninvoice.md): Fetches mandates for downloading e-invoice based on the country code, category, and process type selection. Note: This operation is available only if you have the E-Invoicing feature for Avalara in Early Availabiltiy phase enabled. ## Retrieve a mandate for downloading a credit memo - [GET /v1/credit-memos/{creditMemoKey}/e-invoice/mandate](https://developer.zuora.com/v1-api-reference/api/e-invoicing/geteinvoicecreditmemomandate.md): Fetches mandates for downloading a Credit Memo file based on the country code, category, and process type selection. Note: This operation is available only if you have the E-Invoicing feature for Avalara in Early Availabiltiy phase enabled. ## Retrieve a mandate for downloading a debit memo - [GET /v1/debit-memos/{debitMemoKey}/e-invoice/mandate](https://developer.zuora.com/v1-api-reference/api/e-invoicing/geteinvoicedebitmemomandate.md): Fetches mandates for downloading a Debit Memo file based on the country code, category, and process type selection. Note: This operation is available only if you have the E-Invoicing feature for Avalara in Early Availabiltiy phase enabled. ## Download a file in the specified file format - [GET /v1/invoices/{invoiceKey}/e-invoice/download](https://developer.zuora.com/v1-api-reference/api/e-invoicing/downloadeinvoiceofspecifiedformat.md): Downloads the e-invoice based on the selected file format. The system supports XML, UBL, PNG, or QR codes formats that each country requires or supports. ## Download a credit memo in the specified file format - [GET /v1/credit-memos/{creditMemoKey}/e-invoice/download](https://developer.zuora.com/v1-api-reference/api/e-invoicing/downloadcreditmemoeinvoice.md): Downloads the credit memo based on the specified file format. The system supports XML, UBL, PNG, or QR codes formats that each country requires or supports. ## Download a debit memo in the specified file format - [GET /v1/debit-memos/{debitMemoKey}/e-invoice/download](https://developer.zuora.com/v1-api-reference/api/e-invoicing/downloaddebitmemoeinvoice.md): Downloads the debit memo based on the specified file format. The system supports XML, UBL, PNG, or QR codes formats that each country requires or supports. ## Cancel the e-invoice file for an invoice - [PUT /v1/invoices/{invoiceKey}/e-invoice/cancel](https://developer.zuora.com/v1-api-reference/api/e-invoicing/canceleinvoicebyinvoicekey.md): Cancels the E-Invoice for the given billing document ## List e-invoice file templates - [GET /v1/einvoice/templates](https://developer.zuora.com/v1-api-reference/api/e-invoicing/get_einvoicefiletemplates.md): Lists information about e-invoice file templates. You can query e-invoice file templates by conditions. For example, if your service provider is Sovos, you can use the following example URL to retrieve information about a list of e-invoice file templates for invoices in India: /v1/einvoice/templates?country=IN&documentType=Invoice&provider=Sovos Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Create an e-invoice file template - [POST /v1/einvoice/templates](https://developer.zuora.com/v1-api-reference/api/e-invoicing/post_createeinvoicefiletemplate.md): Creates an e-invoice file templates for your billing documents, including invoices, credit memos, and debit memos. Zuora provides default e-invoice file templates, so you can just customize them as needed. For example, some country specific fields like HSN (Harmonized System of Nomenclature) might be stored on product rate plan charges. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Delete an e-invoice file template - [DELETE /v1/einvoice/templates/{key}](https://developer.zuora.com/v1-api-reference/api/e-invoicing/delete_einvoicefiletemplate.md): Deletes an e-invoice file template by key. The key can be the unique ID or number of an e-invoice file template. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Retrieve an e-invoice file template - [GET /v1/einvoice/templates/{key}](https://developer.zuora.com/v1-api-reference/api/e-invoicing/get_einvoicefiletemplate.md): Retrieves information about an e-invoice file template. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Update an e-invoice file template - [PUT /v1/einvoice/templates/{key}](https://developer.zuora.com/v1-api-reference/api/e-invoicing/put_einvoicefiletemplate.md): Updates information about an e-invoice file template. Note: This operation is available only if you have the E-Invoicing feature in Early Adopter phase enabled. ## Sync the e-Invoice status of an invoice - [PUT /v1/invoices/{invoiceKey}/e-invoice/sync-status](https://developer.zuora.com/v1-api-reference/api/e-invoicing/updateinvoiceinvokesyncstatus.md): Initiates a background polling process to retrieve the latest notification response from the configured e-Invoicing provider and update the e-Invoice status of the e-Invoice. Note: This API can only be invoked when the current e-Invoice status is one of: Processing, ApprovedByAuthority, RetrieveTimeout, or Failed. If the status is different, the request will be rejected. ## Sync the e-Invoice status of a debit memo - [PUT /v1/debit-memos/{debitMemoKey}/e-invoice/sync-status](https://developer.zuora.com/v1-api-reference/api/e-invoicing/updatedebitmemoinvokesyncstatus.md): Initiates a background polling process to retrieve the latest notification response from the configured e-Invoicing provider and update the e-Invoice status of the debit memo. Note: This API can only be invoked when the current e-Invoice status is one of: Processing, ApprovedByAuthority, RetrieveTimeout, or Failed. If the status is different, the request will be rejected. ## Sync the e-Invoice status of a credit memo - [PUT /v1/credit-memos/{creditMemoKey}/e-invoice/sync-status](https://developer.zuora.com/v1-api-reference/api/e-invoicing/updatecreditmemoinvokesyncstatus.md): Initiates a background polling process to retrieve the latest notification response from the configured e-Invoicing provider and update the e-Invoice status of the credit memo. Note: This API can only be invoked when the current e-Invoice status is one of: Processing, ApprovedByAuthority, RetrieveTimeout, or Failed. If the status is different, the request will be rejected. ## Generate an e-invoice file for an invoice - [PUT /v1/invoices/{invoiceKey}/einvoice/generate](https://developer.zuora.com/v1-api-reference/api/e-invoicing/put_generationeinvoicegenerationforinvoices.md): Generates an e-invoice file for an invoice. If the invoice status is Failed during e-invoice generation, you can use Regenerate E-Invoice. Once you fix the errors and trigger the regeneration, the system will resubmit the document to the e-invoicing service provider, and its status will update to Processing. Note: - E-invoicing with Sovos and E-invoicing with PEPPOL Extract are generally available. - E-invoicing with Avalara is in the Early Availability phase. We are actively soliciting feedback from a small set of early availability users before releasing this feature as generally available. If you want to join this early availability program, submit a request at Zuora Global Support. The Regenerate E-Invoice action is available in the Generated status for the PEPPOL service provider. ## Generate an e-invoice file for a credit memo - [PUT /v1/credit-memos/{creditMemoKey}/e-invoice/generate](https://developer.zuora.com/v1-api-reference/api/e-invoicing/put_generateeinvoicefileforcreditmemo.md): Generates an e-invoice file for a credit memo. If the Credit Memo status is Failed during e-invoice generation, you can use Regenerate E-Invoice. Once you fix the errors and trigger the regeneration, the system will resubmit the document to the e-invoicing service provider, and its status will update to Processing. Note: - E-invoicing with Sovos and E-invoicing with PEPPOL Extract are generally available. - E-invoicing with Avalara is in the Early Availability phase. We are actively soliciting feedback from a small set of early availability users before releasing this feature as generally available. If you want to join this early availability program, submit a request at Zuora Global Support. The Regenerate E-Invoice action is available in the Generated status for the PEPPOL service provider. ## Generate an e-invoice file for a debit memo - [PUT /v1/debit-memos/{debitMemoKey}/e-invoice/generate](https://developer.zuora.com/v1-api-reference/api/e-invoicing/put_generateeinvoicefilefordebitmemo.md): Generates an e-invoice file for a debit memo. If the Credit Memo status is Failed during e-invoice generation, you can use Regenerate E-Invoice. Once you fix the errors and trigger the regeneration, the system will resubmit the document to the e-invoicing service provider, and its status will update to Processing. Note: - E-invoicing with Sovos and E-invoicing with PEPPOL Extract are generally available. - E-invoicing with Avalara is in the Early Availability phase. We are actively soliciting feedback from a small set of early availability users before releasing this feature as generally available. If you want to join this early availability program, submit a request at Zuora Global Support. The Regenerate E-Invoice action is available in the Generated status for the PEPPOL service provider.